USE Weather;

SELECT 'Creating Indexes','Ignore any "Duplicate key name" errors';

ALTER IGNORE TABLE Avg10Min ADD CONSTRAINT fk_Avg10Min_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Avg15Min ADD CONSTRAINT fk_Avg15Min_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Barometer ADD CONSTRAINT fk_Barometer_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE DHL ADD INDEX YearMonth (YearMonth);
ALTER IGNORE TABLE DHL ADD INDEX bDate (bDate);
ALTER IGNORE TABLE DHL ADD INDEX YMvpID (YearMonth,vpID);
ALTER IGNORE TABLE DHL ADD CONSTRAINT fk_DHL_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE DHL ADD CONSTRAINT fk_DHL_MHL2 FOREIGN KEY (YearMonth) REFERENCES MHL (YearMonth) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE DHL ADD CONSTRAINT fk_DHL_YMD1 FOREIGN KEY (YearMonthDay) REFERENCES YMD (YearMonthDay) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE DT ADD UNIQUE INDEX RecID (RecID);
ALTER IGNORE TABLE DT ADD INDEX HHMM (HHMM);
ALTER IGNORE TABLE DT ADD INDEX RecIDvpID (vpID,RecID);
ALTER IGNORE TABLE DT ADD INDEX YearMonthDay (YearMonthDay);
ALTER IGNORE TABLE DT ADD INDEX bDate (bDate);
ALTER IGNORE TABLE DT ADD INDEX bTT (bTT);
ALTER IGNORE TABLE DT ADD INDEX bTime (bTime);
ALTER IGNORE TABLE DT ADD INDEX vpIDorgRecID (vpID,vpIDorgRecID);
ALTER IGNORE TABLE DT ADD INDEX YMDvpID (vpID,YearMonthDay);
ALTER IGNORE TABLE DT ADD CONSTRAINT fk_DT_IndexDT1 FOREIGN KEY (RecID) REFERENCES IndexDT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE DT ADD CONSTRAINT fk_DT_IndexDT2 FOREIGN KEY (bTT) REFERENCES IndexDT (bTT) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE DT ADD CONSTRAINT fk_DT_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE DT ADD CONSTRAINT fk_DT_YMD1 FOREIGN KEY (YearMonthDay) REFERENCES YMD (YearMonthDay) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Hourly ADD CONSTRAINT fk_Hourly_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE Hourly ADD CONSTRAINT fk_Hourly_Forecasts1 FOREIGN KEY (ForecastRuleNumber) REFERENCES Forecasts (ForecastRuleNumber) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Humidity ADD CONSTRAINT fk_Humidity_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE IndexDT ADD INDEX rtCaptureTime (rtCaptureTime);
ALTER IGNORE TABLE IndexDT ADD INDEX rtTT (rtTT);
ALTER IGNORE TABLE IndexDT ADD INDEX wxCaptureTime (wxCaptureTime);
ALTER IGNORE TABLE IndexDT ADD INDEX wxTT (wxTT);
ALTER IGNORE TABLE IndexDT ADD INDEX bTT (bTT);
ALTER IGNORE TABLE IndexDT ADD INDEX sTT (sTT);
ALTER IGNORE TABLE IndexDT ADD INDEX vpIDorgRecID (vpID,vpIDorgRecID);
ALTER IGNORE TABLE IndexDT ADD CONSTRAINT fk_IndexDT_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE MHL ADD INDEX bYear (bYear);
ALTER IGNORE TABLE MHL ADD INDEX YvpID (bYear,vpID);
ALTER IGNORE TABLE MHL ADD CONSTRAINT fk_MHL_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE MHL ADD CONSTRAINT fk_MHL_YHL1 FOREIGN KEY (bYear) REFERENCES YHL (bYear) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE MinPtrData ADD INDEX Item (Item);
ALTER IGNORE TABLE MinPtrData ADD INDEX Last (Last);
ALTER IGNORE TABLE MinPtrData ADD INDEX RecID (RecID);
ALTER IGNORE TABLE MinPtrData ADD INDEX Save (Save);
ALTER IGNORE TABLE MinPtrData ADD INDEX bDateTime (bDateTime);
ALTER IGNORE TABLE MinPtrData ADD CONSTRAINT fk_MinPtrData_DT1 FOREIGN KEY (bDateTime) REFERENCES DT (bDateTime) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE MinPtrData ADD CONSTRAINT fk_MinPtrData_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Rain ADD INDEX StormAmount (StormAmount);
ALTER IGNORE TABLE Rain ADD INDEX StormStartedDate (StormStartedDate);
ALTER IGNORE TABLE Rain ADD CONSTRAINT fk_Rain_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Solar ADD CONSTRAINT fk_Solar_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Storms ADD INDEX StormEndedDate (StormEndedDate);
ALTER IGNORE TABLE Storms ADD INDEX StormEndedTime (StormEndedTime);
ALTER IGNORE TABLE Storms ADD CONSTRAINT fk_Storms_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER IGNORE TABLE Storms ADD CONSTRAINT fk_Storms_Rain1 FOREIGN KEY (StormStartedDate) REFERENCES Rain (StormStartedDate) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Temperature ADD CONSTRAINT fk_Temperature_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Wind ADD CONSTRAINT fk_Wind_DT1 FOREIGN KEY (RecID) REFERENCES DT (RecID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE YHL ADD CONSTRAINT fk_YHL_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER IGNORE TABLE Storms ADD INDEX StormStartedTime (StormStartedTime);

ALTER IGNORE TABLE YMD ADD INDEX bDate (bDate);
ALTER IGNORE TABLE YMD ADD CONSTRAINT fk_YMD_Location1 FOREIGN KEY (vpID) REFERENCES Location (vpID) ON DELETE NO ACTION ON UPDATE NO ACTION;

