USE Weather

DELIMITER $$

CREATE PROCEDURE DHL_UPD(IN NewYM INTEGER, NewY SMALLINT, NewvpID TINYINT, NewTHSWHigh INTEGER, NewTHSWHighDT DATETIME, NewUVHigh INTEGER, NewUVHighDT DATETIME, NewDewPointHigh INTEGER, NewDewPointHighDT DATETIME, NewDewPointLow INTEGER, NewDewPointLowDT DATETIME, NewF CHAR(1))
MODIFIES SQL DATA
BEGIN

DECLARE curMaxTHSW INTEGER(3);
DECLARE curMaxTHSWDT DATETIME;
DECLARE maxTHSW INTEGER(3);
DECLARE maxTHSWDT DATETIME;

DECLARE curMaxUV INTEGER(3);
DECLARE curMaxUVDT DATETIME;
DECLARE maxUV INTEGER(3);
DECLARE maxUVDT DATETIME;

DECLARE curMaxDewPoint INTEGER(3);
DECLARE curMaxDewPointDT DATETIME;
DECLARE maxDewPoint INTEGER(3);
DECLARE maxDewPointDT DATETIME;

DECLARE curMinDewPoint INTEGER(3);
DECLARE curMinDewPointDT DATETIME;
DECLARE minDewPoint INTEGER(3);
DECLARE minDewPointDT DATETIME;

SELECT THSWHigh, THSWHighDT, UVHigh, UVHighDT, DewPointHigh, DewPointHighDT, DewPointLow, DewPointLowDT INTO curMaxTHSW, curMaxTHSWDT, curMaxUV, curMaxUVDT, curMaxDewPoint, curMaxDewPointDT, curMinDewPoint, curMinDewPointDT FROM MHL USE INDEX (PRIMARY) WHERE YearMonth = NewYM && vpID = NewvpID;

IF NewTHSWHigh IS NOT NULL && (NewTHSWHigh > curMaxTHSW || curMaxTHSW IS NULL) THEN
    UPDATE MHL SET THSWHigh = NewTHSWHigh, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
END IF;

IF NewTHSWHighDT IS NOT NULL THEN
    SELECT max(THSWHigh) INTO maxTHSW FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID;
    SELECT THSWHighDT INTO maxTHSWDT FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID && THSWHigh = maxTHSW LIMIT 1;
    IF maxTHSW != curMaxTHSW THEN
        UPDATE MHL SET THSWHigh = maxTHSW, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
    IF maxTHSWDT != curMaxTHSWDT || curMaxTHSWDT IS NULL THEN
        UPDATE MHL SET THSWHighDT = maxTHSWDT, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
END IF;

IF NewUVHigh IS NOT NULL && (NewUVHigh > curMaxUV || curMaxUV IS NULL) THEN
    UPDATE MHL SET UVHigh = NewUVHigh, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
END IF;

IF NewUVHighDT IS NOT NULL THEN
    SELECT max(UVHigh) INTO maxUV FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID;
    SELECT UVHighDT INTO maxUVDT FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID && UVHigh = maxUV LIMIT 1;
    IF maxUV != curMaxUV THEN
        UPDATE MHL SET UVHigh = maxUV, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
    IF maxUVDT != curMaxUVDT || curMaxUVDT IS NULL THEN
        UPDATE MHL SET UVHighDT = maxUVDT, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
END IF;

IF NewDewPointHigh IS NOT NULL && (NewDewPointHigh > curMaxDewPoint || curMaxDewPoint IS NULL) THEN
    UPDATE MHL SET DewPointHigh = NewDewPointHigh, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
END IF;

IF NewDewPointHighDT IS NOT NULL THEN
    SELECT max(DewPointHigh) INTO maxDewPoint FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID;
    SELECT DewPointHighDT INTO maxDewPointDT FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID && DewPointHigh = maxDewPoint LIMIT 1;
    IF maxDewPoint != curMaxDewPoint THEN
        UPDATE MHL SET DewPointHigh = maxDewPoint, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
    IF maxDewPointDT != curMaxDewPointDT || curMaxDewPointDT IS NULL THEN
        UPDATE MHL SET DewPointHighDT = maxDewPointDT, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
END IF;

IF NewDewPointLow IS NOT NULL && (NewDewPointLow < curMinDewPoint || curMinDewPoint IS NULL) THEN
    UPDATE MHL SET DewPointLow = NewDewPointLow, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
END IF;

IF NewDewPointLowDT IS NOT NULL THEN
    SELECT min(DewPointLow) INTO minDewPoint FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID;
    SELECT DewPointLowDT INTO minDewPointDT FROM DHL USE INDEX (YMvpID) WHERE YearMonth = NewYM && vpID = NewvpID && DewPointLow = minDewPoint LIMIT 1;
    IF minDewPoint != curMinDewPoint THEN
        UPDATE MHL SET DewPointLow = minDewPoint, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
    if (minDewPointDT != curMinDewPointDT || curMinDewPointDT IS NULL) THEN
        UPDATE MHL SET DewPointLowDT = minDewPointDT, F = NewF WHERE YearMonth = NewYM && vpID = NewvpID;
    END IF;
END IF;

END$$

CREATE TRIGGER DHL_UPD AFTER UPDATE ON DHL
FOR EACH ROW
BEGIN
CALL DHL_UPD(NEW.YearMonth,NEW.bYear,NEW.vpID,NEW.THSWHigh,NEW.THSWHighDT,NEW.UVHigh,NEW.UVHighDT,NEW.DewPointHigh,NEW.DewPointHighDT,NEW.DewPointLow,NEW.DewPointLowDT,NEW.F);
END$$

DELIMITER ;

