/********************************************************************************/
/*  vproweather 1.0.9                                                           */
/*	A program for acquiring data from a Davis Vantage Pro Weather Station.	*/
/*										*/
/* (c)2005-2013 Curt Blank email: curt@curtronics.com				*/
/* VPROWEATHER is covered under the GNU general license. See the attached	*/
/* LICENSE file for details.							*/
/*										*/
/* This software is provided as-is, without any expressed or implied		*/
/* warranties, including, without limitation, the implied warranties of		*/
/* merchantibility and fitness for any particular purpose.			*/
/*										*/
/*										*/
/* mySQLhandler.h - definition of DB columns                                    */
/*      									*/
/*     v0.8-0 cjb - new								*/
/*										*/
/********************************************************************************/

#ifndef __MYSQLHANDLER_H__
#define __MYSQLHANDLER_H__

#ifdef __cplusplus
#define extern "C" {		/* respect c++ callers */
#endif

/* exports */
extern char *getPW();
extern time_t DateTimeCT(char * s1);
extern BOOL mySQLprocess(char * pData, int cid);
extern char* maskPassword(char *pw);
extern void showSQLopts();
extern void doImport();
extern void doExport(int cid);

/* imports */
extern char *opt_host_name;             /* server host (default=localhost) */
extern char *opt_user_name;             /* username (default=login name) */  
extern char *opt_password;              /* password (default=none) */        
extern unsigned int opt_port_num;       /* port number (use built-in value) */
extern char *opt_socket_name;           /* socket name (use built-in value) */
extern char *opt_db_name;               /* database name (default=none) */    
extern unsigned int opt_flags;          /* connection flags (none) */         
extern char *sProfileDataFN;
extern char *sImportDataFN;
extern char *sExportDataFN;
//extern int ConsoleID;
extern BYTE cvtMetricBYTE(BYTE value, int cvtType);
extern int cvtMetricINT(int value, int cvtType);
extern float cvtMetricFLOAT(float value, int cvtType);

extern char rtDateTimeCT[20];
extern char hlDateTimeCT[20];
extern char grDateTimeCT[20];
extern time_t ttrt;          
extern time_t tthl;          
extern time_t ttgr;          
extern time_t ttRun;         

extern RTDATA rcd;                      /* the one and only real time weather packet */
extern HLDATA hld;                      /* the one and only highs/lows packet */       
extern BOOL bRTDSuccess;                                                               
extern BOOL bHLDSuccess;
extern BOOL bGDSuccess;
extern BOOL bMtime;

extern BOOL bVerbose;                   /* Verbose Mode */
extern BOOL bVpro2;
extern BOOL bVerboseSQL;                /* Verbose SQL Mode */
extern BOOL bQuiet;                     /* Surpress all SQL informational messages */
extern BOOL bGetRTD;                    /* Get Real Time Data */
extern BOOL bGetHLD;                    /* Get High Low Data */
extern BOOL bGetGD;                     /* Get graph data */
extern BOOL bCalcSun;
extern BOOL bProfiling;
extern BOOL bImport;
extern BOOL bExport;

extern char SunRise[26];
extern char SunSet[26];
extern char SolarNoon[11];

extern long PID;

extern int ClrSerLock(long PID);
extern void controlC(int sig);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* __NAMES_H__ */
